
#ifndef FRAME_TYPES_H
#define FRAME_TYPES_H

// Echo test request
enum {
    FRAME_TYPE_ECHO = 0x0000,

    // Loopback test request
    FRAME_TYPE_LOOPTEST = 0x5a5a,

    // Stream Data
    FRAME_TYPE_STREAM = 0x5354,

    // Run-mode data
    FRAME_TYPE_ADC_DATA = 0x0100,

    // Register I/O
    FRAME_TYPE_CTRL_REQ = 0x0101,
    FRAME_TYPE_CTRL_ACK = 0x0102,

    // Status
    FRAME_TYPE_STAT = 0x0103,

    // onboard RAM
    FRAME_TYPE_RAM_REQ = 0x0105,
    FRAME_TYPE_RAM_ACK = 0x0106,

    // configuration EEPROM
    FRAME_TYPE_EEPROM_REQ = 0x0107,
    FRAME_TYPE_EEPROM_ACK = 0x0108,

    // Run-mode data
    FRAME_TYPE_VME_DATA = 0x0110,

    // Register I/O for VME master
    FRAME_TYPE_FVME_REQ = 0x0111,
    FRAME_TYPE_FVME_ACK = 0x0112,

    FRAME_TYPE_JTAG_SINGLE = 0x1001,
    FRAME_TYPE_JTAG_SINGLE_ACK = 0x1002,
    FRAME_TYPE_JTAG_BLOCK  = 0x1003,
    FRAME_TYPE_JTAG_BLOCK_ACK  = 0x1004,
};

#endif /* FRAME_TYPES_H */
