//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef MLINK_DRIVER_MLINK_OP_H
#define MLINK_DRIVER_MLINK_OP_H

#include "mlink_dev.h"
#include "mlink_frame_header.h"

#define ML_MIN_RAW_FRAME_BYTES (ML_MIN_RAW_FRAME_WORDS * 4)
#define ML_MAX_RAW_FRAME_BYTES (ML_MAX_RAW_FRAME_WORDS * 4)

int txbuf_allocated(const dev_p dv);
int txbuf_has_space(const dev_p dv, unsigned long nbytes);
unsigned int rxbuf_dirty_avail(const dev_p dv);
unsigned int rxbuf_unread_count(const dev_p dv);
int txbuf_has_data(const dev_p dv);
void txbuf_clear(dev_p dv);
void rxbuf_clear(dev_p dv);
int dv_update_carrier (dev_p dv, int verbose);
int dv_update_dataerr (dev_p dv, int verbose);
int dv_update_errprop (dev_p dv, int verbose);
int dv_update_other_error (dev_p dv, int verbose);
int dv_update_txclkloss (dev_p dv, int verbose);
int dv_update_rxclkloss (dev_p dv, int verbose);

unsigned int dv_try_start_rx(dev_p dv);
int dv_locked_try_start_rx(dev_p dv);
int dv_recv_dma (dev_p dv, ml_dmaop_t * dmaop);
const unsigned char *rxbuf_frame(const dv_rxfifo_t *rxbuf, rxfifo_ptr index);
unsigned int rxbuf_frame_len(const dv_rxfifo_t *rxbuf, rxfifo_ptr index);
unsigned int rxbuf_buf_size(const dv_rxfifo_t *rxbuf, rxfifo_ptr index);
const frame_hdr_t *rxbuf_writer_frame_header(const dv_rxfifo_t *rxbuf);

#endif // MLINK_DRIVER_MLINK_OP_H
