//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef MLINK_DRIVER_MLINK_OP_PEX_H
#define MLINK_DRIVER_MLINK_OP_PEX_H

#include "mlink_dev.h"

void dv_write_disable (dev_p dv); /* RX */
void dv_read_disable (dev_p dv); /* TX */
void dv_xmit_disable (dev_p dv);
void dv_int_disable (dev_p dv);
void dv_recv_imb (dev_p dv);
int dv_send_dma (dev_p dv, ml_dmaop_ro_t dmaop);
int dv_poll_event(dev_p dv, ml_poll_ev_op_t *op);
//void test_pulse(dev_p dv);
//void test_pin_up(dev_p dv);
//void test_pin_down(dev_p dv);
void dv_receive_packets(dev_p dv);
void ml_clear_imb_interrupt_request(dev_p dv);

void dv_write_pexml_hw_reg(dev_p dv, uint32_t data, uint32_t hw_addr);
uint32_t dv_read_pexml_hw_reg(dev_p dv, uint32_t hw_addr);

void dv_set_irq_mask_bits(dev_p dv, uint32_t bits_set, uint32_t bits_clear, int force_update);
uint32_t dv_calc_rx_dma_w32_size(dev_p dv);
void update_link_status(dev_p dv);
void update_board_id(dev_p dv);
void update_board_info(dev_p dv);
void print_board_info(dev_p dv);
int dv_write_port(dev_p dv, unsigned int port, u32 offset, u32 data);
int dv_read_port(dev_p dv, unsigned int port, u32 offset, u32 *data);
int dv_caps_gtx_ctrl(dev_p dv);
int dv_write_flasher(dev_p dv, u32 offset, u32 data);
int dv_read_flasher(dev_p dv, u32 offset, u32 *data);

#endif // MLINK_DRIVER_MLINK_OP_PEX_H
