#ifndef PEXML_PORTS_H
#define PEXML_PORTS_H

enum {
    // relative to HW_CSR_PORT_x_START
    PEXML_GTX_CTRL_REG = 0,
    PEXML_GTX_STAT_REG = 4,
    PEXML_SFP_CTRL_REG = 8,
    PEXML_SFP_STAT_REG = 12,
};

// GTX Register bit map (gtxe2c_mlink.v)
enum {
    GTX_CTRL_BIT_RESET = 0,
    GTX_CTRL_BIT_LOOPBACK = 1,
    GTX_CTRL_BIT_RXPD0 = 2,
    GTX_CTRL_BIT_RXPD1 = 3,
    GTX_CTRL_BIT_TXPD0 = 4,
    GTX_CTRL_BIT_TXPD1 = 5,
};

enum {GTX_CTRL_RESET = (1 << GTX_CTRL_BIT_RESET)};
enum {GTX_CTRL_LOOPBACK = (1 << GTX_CTRL_BIT_LOOPBACK)};
enum {GTX_CTRL_RXPD = (1 << GTX_CTRL_BIT_RXPD0) | (1 << GTX_CTRL_BIT_RXPD1)};
enum {GTX_CTRL_TXPD = (1 << GTX_CTRL_BIT_TXPD0) | (1 << GTX_CTRL_BIT_TXPD1)};

enum { HW_CSR_PORT_CONTROL_BITS_GTX_ENABLE = 0 };
enum { HW_CSR_PORT_CONTROL_BITS_GTX_DISABLE = GTX_CTRL_RXPD | GTX_CTRL_TXPD };

// SFP Register bit map (pexmlk7.v)
enum {
    SFP_CTRL_BIT_RT_SEL     = 0,
    SFP_CTRL_BIT_TX_DISABLE = 1,
    SFP_CTRL_BIT_IIC_SCL    = 4,
    SFP_CTRL_BIT_IIC_SCL_OE = 5,
    SFP_CTRL_BIT_IIC_SDA    = 6,
    SFP_CTRL_BIT_IIC_SDA_OE = 7,
};

enum {
    SFP_CTRL_RT_SEL     = 1 << SFP_CTRL_BIT_RT_SEL,
    SFP_CTRL_TX_DISABLE = 1 << SFP_CTRL_BIT_TX_DISABLE,
    SFP_CTRL_IIC_SCL    = 1 << SFP_CTRL_BIT_IIC_SCL,
    SFP_CTRL_IIC_SCL_OE = 1 << SFP_CTRL_BIT_IIC_SCL_OE,
    SFP_CTRL_IIC_SDA    = 1 << SFP_CTRL_BIT_IIC_SDA,
    SFP_CTRL_IIC_SDA_OE = 1 << SFP_CTRL_BIT_IIC_SDA_OE,
};
enum {
    SFP_STAT_BIT_MOD_DETECT = 0,
    SFP_STAT_BIT_LOS        = 1,
    SFP_STAT_BIT_TX_FAULT   = 2,
    SFP_STAT_BIT_IIC_SCL    = 4,
    SFP_STAT_BIT_IIC_SDA    = 6,
};
enum {
    SFP_STAT_MOD_DETECT = 1 << SFP_STAT_BIT_MOD_DETECT,
    SFP_STAT_LOS        = 1 << SFP_STAT_BIT_LOS,
    SFP_STAT_TX_FAULT   = 1 << SFP_STAT_BIT_TX_FAULT,
    SFP_STAT_IIC_SCL    = 1 << SFP_STAT_BIT_IIC_SCL,
    SFP_STAT_IIC_SDA    = 1 << SFP_STAT_BIT_IIC_SDA,
};

#endif // PEXML_PORTS_H
